# Linear structures

Implementation of all common linear data structures in Dart.  

[![Pub](https://img.shields.io/pub/v/linear_structures)](https://pub.dartlang.org/packages/linear_structures)

## Usage
add `linear_structures` as a [dependency in your pubspec.yaml file](https://flutter.io/using-packages/).

```dart
dependencies:
  flutter:
    sdk: flutter
  linear_structures: 1.1.2
```

Run `pub get` to install.

### Content
* [SinglyLinkedList](https://github.com/heda7/linear_structures/blob/master/lib/singly_linked_list.dart)
* [DoublyLinkedList](https://github.com/heda7/linear_structures/blob/master/lib/doubly_linked_list.dart)
* [Stack](https://github.com/heda7/linear_structures/blob/master/lib/stack.dart)
* [Queue](https://github.com/heda7/linear_structures/blob/master/lib/queue.dart)

### Example

```dart
DoublyLinkedList<String> list = DoublyLinkedList();
print("list is empty: ${list.isEmpty}");

list.addLast("B");
list.addFirst("A");
list.addLast("C");

print(list.getAll());
print("removed element: ${list.removeLast()}");
print(list.getAll());
```